local QSA_BEGINSQUEST = "This item begins a quest!\n%s"
local QSA_FADETIME = 5

local alertedItems = { }
local function AlertCheck(bag)
	local alert
	alertedItems = alertedItems or { }
	for slot = 1, GetContainerNumSlots(bag) do
		local _, questID, isActive = GetContainerItemQuestInfo(bag, slot)
		local itemID = GetContainerItemID(bag, slot)
		local link = GetContainerItemLink(bag, slot)
		if questID then
			local questCompleted = IsQuestFlaggedCompleted(questID)
			if not (isActive or alertedItems[itemID] or questCompleted) then
				alert = link
				alertedItems[itemID] = questID
			end
		end
	end
	if alert then
		PlaySound("LevelUp", "Master")
		QSAlertFrame.fadeTime = QSA_FADETIME
		QSAlertFrameText:SetFormattedText(QSA_BEGINSQUEST, alert)
		QSAlertFrame:Show()
	end
end

local function CleanUpAlertedItems()
	alertedItems = { }
	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do
			local _, questID, isActive = GetContainerItemQuestInfo(bag, slot)
			local itemID = GetContainerItemID(bag, slot)
			local link = GetContainerItemLink(bag, slot)
			if questID then
				local questCompleted = IsQuestFlaggedCompleted(questID)
				if not (isActive or alertedItems[itemID] or questCompleted) then
					alertedItems[itemID] = questID
				end
			end
		end
	end
end

function QSAlertFrame_OnLoad(self)
	self:RegisterEvent"PLAYER_ENTERING_WORLD"
	self:RegisterEvent"BAG_UPDATE"
end

function QSAlertFrame_OnEvent(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		for bag = 0, 4 do
			AlertCheck(bag)
		end
	elseif event == "BAG_UPDATE" then
		local bag = ...
		AlertCheck(bag)
	end	
end

function QSAlertFrame_OnUpdate(self, elapsed)
	if self.fadeTime then
		if elapsed >= self.fadeTime then
			self:Hide()
		else
			self.fadeTime = self.fadeTime - elapsed
			local alpha = self.fadeTime / QSA_FADETIME
			self:SetAlpha(alpha)
		end
	end
end